commit 081d99b40f6bb2cad39c497dcc7f2e7d98e3811d
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Wed Apr 11 09:13:17 2018 +0200

    ref #7086 Add property and label to character details view

diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/ColorResources.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/ColorResources.java
index 619413369..1a1d14b9d 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/ColorResources.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/model/ColorResources.java
@@ -54,6 +54,7 @@ public class ColorResources {
 		registerColor(registry, Resources.COLOR_COMPOSITE_IRRELEVANT, 241,139,18);
 		registerColor(registry, Resources.SEARCH_VIEW_FOREGROUND, 192, 192, 192);
 		registerColor(registry, Resources.SEARCH_VIEW_FOCUS, 0, 0, 0);
+		registerColor(registry, Resources.BLACK, 0, 0, 0);
 		registerColor(registry, Resources.COLOR_LIST_BACKGROUND, 150,150,150);
 		registerColor(registry, Resources.COLOR_FONT_DEFAULT, 0,0,0);
 		registerColor(registry, Resources.COLOR_TEXT_DISABLED, 150,150,150);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/Resources.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/Resources.java
index 658abe1e9..36359b79a 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/Resources.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/Resources.java
@@ -1,8 +1,8 @@
 /**
 * Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy 
+* European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
-* 
+*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
@@ -19,10 +19,10 @@ package eu.etaxonomy.taxeditor.preference;
  * @version 1.0
  */
 public interface Resources {
-	
+
 	/* ***************************************************************************************
 	FONTS
-	************************************************************************************** */	
+	************************************************************************************** */
 	/** Constant <code>ACCEPTED_TAXON_FONT="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
 	public static final String ACCEPTED_TAXON_FONT = "eu.etaxonomy.taxeditor.preferences.fontDefinition.nameEditor.accepted";
 	/** Constant <code>SYNONYM_FONT="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
@@ -33,14 +33,14 @@ public interface Resources {
 	public static final String CONCEPT_FONT = "eu.etaxonomy.taxeditor.preferences.fontDefinition.nameEditor.concept";
 	/** Constant <code>FONT_DEFAULT_PROMPT="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
 	public static final String FONT_DEFAULT_PROMPT = "eu.etaxonomy.taxeditor.preferences.fontDefinition.nameEditor.default";
-	
+
 	/** Constant <code>FONT_SEARCH_VIEW_ACCEPTED="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
 	public static final String FONT_SEARCH_VIEW_ACCEPTED = "eu.etaxonomy.taxeditor.preferences.fontDefinition.searchView.accepted";
 	/** Constant <code>FONT_SEARCH_VIEW_SYNONYM="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
 	public static final String FONT_SEARCH_VIEW_SYNONYM = "eu.etaxonomy.taxeditor.preferences.fontDefinition.searchView.synonym";
 	/** Constant <code>FONT_SEARCH_VIEW_OTHER="eu.etaxonomy.taxeditor.preferences.font"{trunked}</code> */
 	public static final String FONT_SEARCH_VIEW_OTHER = "eu.etaxonomy.taxeditor.preferences.fontDefinition.searchView.other";
-	
+
 	/* ***************************************************************************************
 	COLORS
 	************************************************************************************** */
@@ -50,17 +50,19 @@ public interface Resources {
 	public static final String COLOR_CONTROL_SELECTED = "eu.etaxonomy.taxeditor.preferences.colorDefinition.nameEditor.colorContainerSelected";
 	/** Constant <code>COLOR_CONTROL_SELECTED_FOCUS="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_CONTROL_SELECTED_FOCUS = "eu.etaxonomy.taxeditor.preferences.colorDefinition.nameEditor.colorContainerSelectedFocus";
-	
+
 	/** Constant <code>COLOR_COMPOSITE_BACKGROUND="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_COMPOSITE_BACKGROUND = "eu.etaxonomy.taxeditor.preferences.colorDefinition.colorCompositeBackground";
 	/** Constant <code>COLOR_COMPOSITE_IRRELEVANT="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_COMPOSITE_IRRELEVANT = "eu.etaxonomy.taxeditor.preferences.colorDefinition.colorCompositeIrrelevant";
-	
+
 	/** Constant <code>SEARCH_VIEW_FOREGROUND="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String SEARCH_VIEW_FOREGROUND = "eu.etaxonomy.taxeditor.preferences.colorDefinition.searchView.foreground";
 	/** Constant <code>SEARCH_VIEW_FOCUS="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String SEARCH_VIEW_FOCUS = "eu.etaxonomy.taxeditor.preferences.colorDefinition.searchView.focus";
 
+	public static final String BLACK = "eu.etaxonomy.taxeditor.preferences.colorDefinition.black";
+
 	/** Constant <code>COLOR_LIST_BACKGROUND="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_LIST_BACKGROUND = "eu.etaxonomy.taxeditor.preferences.colorDefinition.listBackground";
 	/** Constant <code>COLOR_FONT_DEFAULT="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
@@ -69,19 +71,19 @@ public interface Resources {
 	public static final String COLOR_TEXT_DISABLED = "eu.etaxonomy.taxeditor.preferences.colorDefinition.textDisabled";
 	/** Constant <code>COLOR_TEXT_DISABLED_BACKGROUND="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_TEXT_DISABLED_BACKGROUND = "eu.etaxonomy.taxeditor.preferences.colorDefinition.textBackgroundDisabled";
-	
+
 	/** Constant <code>COLOR_DRAG_ENTER="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_DRAG_ENTER = "eu.etaxonomy.taxeditor.preferences.colorDefinition.nameEditor.colorContainerDragEnter";
 	/** Constant <code>COLOR_LIST_EVEN="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_LIST_EVEN = "eu.etaxonomy.taxeditor.preferences.colorDefinition.listBackgroundEven";
 	/** Constant <code>COLOR_LIST_ODD="eu.etaxonomy.taxeditor.preferences.colo"{trunked}</code> */
 	public static final String COLOR_LIST_ODD = "eu.etaxonomy.taxeditor.preferences.colorDefinition.listBackgroundOdd";
-	
+
 	public static final String COLOR_PARSE_ERROR = "eu.etaxonomy.taxeditor.preferences.colorDefinition.parseError";
-	
+
 	public static final String COLOR_DISABLED_EDITOR = "eu.etaxonomy.taxeditor.preferences.colorDefinition.disabledEditor";
-	
+
 	public static final String COLOR_EDITOR_ERROR = "eu.etaxonomy.taxeditor.preferences.colorDefinition.editorError";
-	
-	
+
+
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
index 8fed27317..43e5bcb06 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
@@ -8,14 +8,18 @@
 */
 package eu.etaxonomy.taxeditor.ui.section.feature;
 
+import org.eclipse.swt.widgets.Label;
 import org.eclipse.ui.forms.widgets.ExpandableComposite;
 
 import eu.etaxonomy.cdm.model.description.Character;
+import eu.etaxonomy.taxeditor.model.ColorResources;
+import eu.etaxonomy.taxeditor.preference.Resources;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
-import eu.etaxonomy.taxeditor.ui.section.vocabulary.DefinedTermDetailElement;
+import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
+import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 import eu.etaxonomy.taxeditor.ui.section.vocabulary.MeasurementUnitCollectionSection;
 import eu.etaxonomy.taxeditor.ui.section.vocabulary.RecommendedModifierVocabulariesCollectionSection;
 import eu.etaxonomy.taxeditor.ui.section.vocabulary.StateVocabularyCollectionSection;
@@ -27,7 +31,7 @@ import eu.etaxonomy.taxeditor.ui.section.vocabulary.StatisticalMeasureCollection
  * @since Dec 21, 2017
  *
  */
-public class CharacterDetailElement extends DefinedTermDetailElement<Character> {
+public class CharacterDetailElement extends AbstractCdmDetailElement<Character> {
 
     private ICdmFormElement parentFormElement;
 
@@ -50,8 +54,17 @@ public class CharacterDetailElement extends DefinedTermDetailElement<Character>
 
 	@Override
 	protected void createControls(ICdmFormElement formElement, Character entity, int style) {
-	    super.createControls(formElement, entity, style);
 	    this.parentFormElement = formElement;
+	    Label lblStructure = new Label(formElement.getLayoutComposite(), style);
+	    lblStructure.setText("Structure");
+	    Label lblStructureText = new Label(formElement.getLayoutComposite(), style);
+	    lblStructureText.setText(entity.getStructure().getFeature().getLabel());
+	    lblStructureText.setForeground(ColorResources.getColor(Resources.BLACK));
+	    Label lblProperty = new Label(formElement.getLayoutComposite(), style);
+	    lblProperty.setText("Property");
+	    Label lblPropertyText = new Label(formElement.getLayoutComposite(), style);
+	    lblPropertyText.setForeground(ColorResources.getColor(Resources.BLACK));
+	    lblPropertyText.setText(entity.getProperty().getFeature().getLabel());
 	    supportsQuantitativeData = formFactory.createCheckbox(formElement, "Supports Quantitative Data", entity.isSupportsQuantitativeData(), style);
 	    supportsCategoricalData = formFactory.createCheckbox(formElement, "Supports Categorical Data", entity.isSupportsCategoricalData(), style);
 
@@ -79,15 +92,15 @@ public class CharacterDetailElement extends DefinedTermDetailElement<Character>
                            );
             sectionModifierVocabularies.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
             sectionModifierVocabularies.setEntity(getEntity());
-
-            //if any type is selected disable supportsTextData
-            entity.setSupportsTextData(false);
         }
     }
 
 	@Override
 	public void handleEvent(Object eventSource) {
-	    super.handleEvent(eventSource);
+	    if(eventSource == supportsQuantitativeData || eventSource == supportsCategoricalData){
+	        //if any type is selected disable supportsTextData
+	        getEntity().setSupportsTextData(false);
+	    }
 	    if(eventSource == supportsQuantitativeData){
 	        getEntity().setSupportsQuantitativeData(supportsQuantitativeData.getSelection());
 	        if(supportsQuantitativeData.getSelection()){